(function(window, document, $) {
	var trustarc_Fixed = {
		init: function(options) {
			Init(options);
		}
	};

	function Init(options) {
		_isMobile = options.mobile;
		_isFixedHeader = options.fixed_header;
		_isWordpress = $('body').hasClass('wordpress');
		_isHowTos = $('body').hasClass('how-to');
		_isGallery = $('body').hasClass('gallery');

		_headerHeight = $('header').height();

		if (_isWordpress || _isHowTos || _isGallery || !_isFixedHeader)
		{
			$('#consent_blackbar').css('position', 'fixed');
			$('#consent_blackbar').css('top', '0');

			window.addEventListener('resize', isTrustArcLoaded, false);
		}
		else if (!_isMobile)
		{
			window.addEventListener('scroll', _trustarc_ScrollListener, false);
		}

		isTrustArcLoaded();
	}

	function isTrustArcLoaded() {
		setTimeout(function () {
			if ($('#consent_blackbar div').length == 0 && _maxLimit-- > 0) {
				isTrustArcLoaded();
			}
			else
			{
				if ($('#consent_blackbar div').length > 0)
				{
					if ($('#consent_blackbar > div').length > 1)
					{
						$('#consent_blackbar > div:last').remove();
					}

					if (!_isLoaded)
					{
						$("#truste-consent-button, #truste-ccpa-optout").on('click', function(){
							$('body').css('padding-top', _originalBodyPadding + 'px');

							if (_isMobile)
							{
								$('header').css('top', '0');
							}
						});

						_isLoaded = true;
						$('#consent_blackbar').css('width', '100%');
						$('#consent_blackbar').css('z-index', '1000000');
						_containerHeight = $('#consent_blackbar').height();
						_originalBodyPadding = parseFloat($('body').css('padding-top'));
						var bodyPaddingTop = (_originalBodyPadding + _containerHeight) + 'px';
						$('body').css('padding-top', bodyPaddingTop);

						if (_isMobile)
						{
							$('#consent_blackbar').css('position', 'fixed');
							$('#consent_blackbar').css('top', '0');
							$('header').css('top', _containerHeight + 'px');
						}
					}
					else
					{
						var acuratePadding = _originalBodyPadding + _containerHeight;

						if (parseFloat($('body').css('padding-top')) > acuratePadding)
						{
							$('body').css('padding-top', acuratePadding);
						}
					}
				}
			}
		}, 20);
	}

	var _trustarc_ScrollListener = function() {
		if (_timeout) {
			clearTimeout(_timeout);
		}

		_timeout = setTimeout(_trustarcMakeFixed, 5);
	};

	var _trustarcMakeFixed = function() {
		if ($('#consent_blackbar div').length > 0)
		{
			var currentHeaderHeight = $('header').height();
			var headerTop = $('header').position().top;
			var consentPosition = $('#consent_blackbar').css('position');
			var isFixedComponent = $('header').hasClass('fixedcomponentwidth');

			if (consentPosition == 'fixed' && (_containerHeight + currentHeaderHeight - headerTop)  >= _headerHeight && (currentHeaderHeight + headerTop) !== 0)
			{
				$('#consent_blackbar').css('position', '');
			}
			else if ((isFixedComponent && headerTop < 0 && (currentHeaderHeight + headerTop) == 0) || (isFixedComponent && (currentHeaderHeight - _containerHeight + headerTop) <= 0))
			{
				$('#consent_blackbar').css('position', 'fixed');
			}
			else
			{
				$('#consent_blackbar').css('position', '');
			}
		}
	};

	var _timeout;
	var _containerHeight;
	var _headerHeight;
	var _isMobile;
	var _isFixedHeader;
	var _isWordpress;
	var _isHowTos;
	var _isGallery;
	var _originalBodyPadding;
	var _isLoaded = false;
	var _maxLimit = 250;
	window.trustarc_Fixed = trustarc_Fixed;
}(window, document, window.jQuery));
