/*======================================================================*\
|| #################################################################### ||
|| # vBulletin [#]version[#]
|| #################################################################### ||
\*======================================================================*/

/**
* Initializes the MQ images, so they are clickable. Additionally, it redoes
* the coloring of the image based on the current value of the cookie. This
* is helpful if a user uses the back button.
*
* @param	object	The object to search within for MQ images.
*/
function mq_init(obj)
{
	var cookie_ids = fetch_cookie(COOKIE_PREFIX + 'vbulletin_multiquote');
	if (cookie_ids != null && cookie_ids != '')
	{
		cookie_ids = cookie_ids.split(',');
	}
	else
	{
		cookie_ids = new Array();
	}

	var postid, items;

	if (MASTERSTYLEID == -1)
	{
		items = fetch_tags(obj, 'img');
	}
	else
	{
		items = fetch_tags(obj, 'a');
	}

	for (var i = 0; i < items.length; i++)
	{
		if (items[i].id && items[i].id.substr(0, 3) == 'mq_')
		{
			postid = items[i].id.substr(3);
			items[i].onclick = function(e) { return mq_click(this.id.substr(3)); };
			change_mq_image(postid, (PHP.in_array(postid, cookie_ids) > -1 ? true : false));
		}
	}
}

/**
* Callback function to when an MQ image is clicked. Modifies the cookie and
* updates the look of the image to suit.
*
* @param	integer	Post ID of the image clicked.
*
* @return	false	Always returns false to ensure any href event does not run
*/
function mq_click(postid)
{
	var cookie_ids = fetch_cookie(COOKIE_PREFIX + 'vbulletin_multiquote');

	var cookie_text = new Array();
	var is_selected = false;

	if (cookie_ids != null && cookie_ids != '')
	{
		cookie_ids = cookie_ids.split(',');

		for (i in cookie_ids)
		{
			if (!YAHOO.lang.hasOwnProperty(cookie_ids, i))
			{
				continue;
			}

			if (cookie_ids[i] == postid)
			{
				is_selected = true;
			}
			else if (cookie_ids[i])
			{
				cookie_text.push(cookie_ids[i]);
			}
		}
	}

	// flip the image to the other option
	change_mq_image(postid, (is_selected ? false : true));

	// if we don't have the postid in the cookie, add it
	if (!is_selected)
	{
		cookie_text.push(postid);
		if (typeof mqlimit != 'undefined' && mqlimit > 0)
		{
			for (var i = 0; i < (cookie_text.length - mqlimit); i++)
			{
				var removal = cookie_text.shift();
				change_mq_image(removal, false);
			}
		}
	}

	set_cookie(COOKIE_PREFIX + 'vbulletin_multiquote', cookie_text.join(','));

	// update the value of the multiquote count on the magicbar if it is defined
	if (window.vB_Magicbar)
	{
		window.vB_Magicbar.multiquote_count();
	}

	return false;
}

/**
* Changes the MQ image to show as being selected or unselected
*
* @param	integer	ID of the post whose MQ button is changing
* @param	boolean	Whether to make the image selected or not
*/
function change_mq_image(postid, to_selected)
{
	var mq_obj = fetch_object('mq_' + postid);

	if (mq_obj)
	{
		var mq_obj_icon = fetch_object('mq_' + postid + '_icon');

		if (to_selected == true)
		{
			if (MASTERSTYLEID == -1)
			{
				mq_obj.src = mq_obj.src.replace(/\/multiquote_off\.([a-zA-Z0-9]+)$/, '/multiquote_on.$1');
			}
			else
			{
				if (MASTERSTYLEID == -2)
				{
					mq_obj.className = mq_obj.className.replace('m-btn m-hollow ', 'm-btn ');
				}
				else
				{
					mq_obj.className = mq_obj.className.replace('button hollow ', 'button ');
				}

				if (mq_obj_icon)
				{
					mq_obj_icon.className = mq_obj_icon.className.replace('fa-square', 'fa-check-square');
				}
			}
		}
		else
		{
			if (MASTERSTYLEID == -1)
			{
				mq_obj.src = mq_obj.src.replace(/\/multiquote_on\.([a-zA-Z0-9]+)$/, '/multiquote_off.$1');
			}
			else
			{
				if (MASTERSTYLEID == -2)
				{
					// For when buttons initially have hollow class to them
					mq_obj.className = mq_obj.className.replace('m-btn ', 'm-btn m-hollow ');
					mq_obj.className = mq_obj.className.replace('m-hollow m-hollow ', 'm-hollow ');
				}
				else
				{
					// For when buttons initially have hollow class to them
					mq_obj.className = mq_obj.className.replace('button ', 'button hollow ');
					mq_obj.className = mq_obj.className.replace('hollow hollow ', 'hollow ');
				}

				if (mq_obj_icon)
				{
					mq_obj_icon.className = mq_obj_icon.className.replace('fa-check-square', 'fa-square');
				}

				mq_obj.blur();
			}
		}
	}
}

mq_init(fetch_object('posts'));
