/*======================================================================*\
|| #################################################################### ||
|| # vBulletin [#]version[#]
|| #################################################################### ||
\*======================================================================*/

var qr_repost = false;
var qr_errors_shown = false;
var qr_active = false;
var qr_ajax = null;
var clickedelm = false;

var qr_magicbar = false;
var QR_EditorID = false;

/**
* Initializes the quick reply system
*/
function qr_init()
{
	var ekeys = Object.keys(vB_Editor);

	for (var i = 0; i < ekeys.length; i++)
	{
		QR_EditorID = ekeys[i];

		if (typeof vB_Editor[QR_EditorID].editorname == 'undefined')
		{
			vB_Editor[QR_EditorID].editorname = '';
		}

		if (vB_Editor[QR_EditorID].ismagibar)
		{
			qr_magicbar = QR_EditorID;
		}

		var objparents = jQuery('#' + QR_EditorID).parents('div[id^="posts"]'),
			obj;
		if (objparents.length > 0)
		{
			obj = fetch_object(objparents[0].id);
		}
		else
		{
			obj = fetch_object('posts');
		}

		qr_disable_controls();
		qr_init_buttons(obj);
	}

}

/**
* Steps through the given object activating all quick reply buttons it finds
*
* @param	object	HTML object to search
*/
function qr_init_buttons(obj)
{
	var anchors = fetch_tags(obj, 'a');
	for (var i = 0; i < anchors.length; i++)
	{
		if (anchors[i].id && anchors[i].id.substr(0, 3) == 'qr_')
		{
			anchors[i].onclick = function(e) {
				e.stopPropagation();
				return qr_activate(this.id.substr(3));
			};
		}
	}
}

/**
* Disables the controls in the quick reply system
*/
function qr_disable_controls()
{
	if (require_click)
	{
		if (qr_magicbar) {
			fetch_object('qr_postid').value = 0;
		}
		else {
			fetch_object('qr_postid' + vB_Editor[QR_EditorID].editorname).value = 0;
			fetch_object('qr_quickreply' + vB_Editor[QR_EditorID].editorname).checked = false;
		}

		vB_Editor[QR_EditorID].disable_editor(vbphrase['click_quick_reply_icon']);

		var qr_sig = fetch_object('cb_signature');
		if (qr_sig != null)
		{
			qr_sig.disabled = true;
		}

		active = false;
		qr_active = false;
	}
	else
	{
		vB_Editor[QR_EditorID].write_editor_contents('');

		if (window.vB_Magicbar)
		{
			fetch_object('qrcontent').style.display = 'none';
			fetch_object('qr_quickreply').checked = false;
			fetch_object('qr_quickreply').disabled = true;
		}
		qr_active = true;
	}

	if (threaded_mode != 1)
	{
		fetch_object('qr_quickreply' + vB_Editor[QR_EditorID].editorname).disabled = true;
	}

}

/**
* Activates the controls in the quick reply system
*
* @param	integer	Post ID of the post to which we are replying
*
* @return	boolean	false
*/
function qr_activate(postid)
{
	if (window.vB_Magicbar && qr_magicbar)
	{
		QR_EditorID = qr_magicbar;
	}

	var id = vB_Editor[QR_EditorID].editorname;

	var qr_collapse = fetch_object('collapseobj_quickreply' + id);
	if (qr_collapse && qr_collapse.style.display == "none")
	{
		toggle_collapse('quickreply' + id);
	}

	fetch_object('qr_postid' + id).value = postid;
	if (fetch_object('qr_specifiedpost' + id))
	{
		fetch_object('qr_specifiedpost' + id).value = 1;
	}
	//fetch_object('qr_preview' + id).focus();
	fetch_object('qr_quickreply' + id).disabled = false;

	var qr_sig = fetch_object("cb_signature" + id);
	if (qr_sig)
	{
		qr_sig.disabled = false;
		// Workaround for 3.5 Bug # 1618: Set checked as Firefox < 1.5 "forgets" that when checkbox is disabled via JS
		qr_sig.checked = true;
	}

	if (qr_active == false)
	{
		vB_Editor[QR_EditorID].enable_editor('');
	}

	// Scroll to Quick Reply
	var scroll = fetch_object('qr_scroll' + id);
	if (scroll)
	{
		scroll.scrollIntoView(false);
	}

	if (window.vB_Magicbar)
	{
		// Open Quick Reply Editor from a post
		$('#qr_threadtitle').html('');

		fetch_object('qrcontent').style.display = 'block';
	}
	
	if (!$('#magicbar' + ' .cke_button__textcolor').hasClass('eventadded'))
	{
		$('#magicbar' +' .cke_button__textcolor').on('click', function() {
			$('.cke_panel').addClass('fixzindex');
		});
		
		$('#magicbar' + ' .cke_button__textcolor').addClass('eventadded');
	}

	qr_active = true;

	return false;
}

/**
* Checks the contents of the new reply and decides whether or not to allow it through
*
* @param	object	<form> object containing quick reply
* @param	integer	Minimum allowed characters in message
*
* @return	boolean
*/
function qr_prepare_submit(formobj, minchars)
{
	if (qr_repost == true)
	{
		return true;
	}

	// Set the corresponding QR Editor of the form submitted
	QR_EditorID = jQuery(formobj).data('editor') || QR_EditorID;

	if (!allow_ajax_qr || !AJAX_Compatible)
	{
		// not last page, or threaded mode - do not attempt to use AJAX
		return qr_check_data(formobj, minchars);
	}
	else if (qr_check_data(formobj, minchars))
	{
		if (typeof vb_disable_ajax != 'undefined' && vb_disable_ajax > 0)
		{
			// couldn't initialize, return true to allow click to go through
			return true;
		}

		if (YAHOO.util.Connect.isCallInProgress(qr_ajax))
		{
			return false;
		}

		if (clickedelm == formobj.preview.value)
		{
			return true;
		}
		else
		{
			var submitstring = 'ajax=1';
			if (typeof ajax_last_post['t' + formobj.t.value] != 'undefined')
			{
				submitstring += '&ajax_lastpost=' + PHP.urlencode(ajax_last_post['t' + formobj.t.value]);
			}

			for (var i = 0; i < formobj.elements.length; i++)
			{
				var obj = formobj.elements[i];

				if (obj.name && !obj.disabled)
				{
					switch (obj.type)
					{
						case 'text':
						case 'textarea':
						case 'hidden':
							submitstring += '&' + obj.name + '=' + PHP.urlencode(obj.value);
							break;
						case 'checkbox':
						case 'radio':
							submitstring += obj.checked ? '&' + obj.name + '=' + PHP.urlencode(obj.value) : '';
							break;
						case 'select-one':
							submitstring += '&' + obj.name + '=' + PHP.urlencode(obj.options[obj.selectedIndex].value);
							break;
						case 'select-multiple':
							for (var j = 0; j < obj.options.length; j++)
							{
								submitstring += (obj.options[j].selected ? '&' + obj.name + '=' + PHP.urlencode(obj.options[j].value) : '');
							}
							break;
					}
				}
			}

			var id = vB_Editor[QR_EditorID].editorname;

			fetch_object('qr_posting_msg' + id).style.display = '';
			document.body.style.cursor = 'wait';

			qr_ajax_post(formobj.action, submitstring, formobj.id);
			if (id != '' && document.getElementById(id + '_textarea') != null)
			{
				document.getElementById(id + '_textarea').value = '';
			}
			return false;
		}
	}
	else
	{
		return false;
	}
}

/**
* Submit handler for resubmit after a failed AJAX attempt.
* Adds an extra input to note the failure on the PHP side.
*/
function qr_resubmit(id)
{
	qr_repost = true;

	var extra_input = document.createElement('input');
	extra_input.type = 'hidden';
	extra_input.name = 'ajaxqrfailed';
	extra_input.value = '1';
	fetch_object('qrform' + id).appendChild(extra_input);

	fetch_object('qrform' + id).submit();
}

/**
* Works with form data to decide what to do
*
* @param	object	<form> object containing quick reply
* @param	integer	Minimum allowed characters in message
*
* @return	boolean
*/
function qr_check_data(formobj, minchars)
{
	var id = vB_Editor[QR_EditorID].editorname;

	switch (fetch_object('qr_postid' + id).value)
	{
		case '0':
		{
			alert(vbphrase['click_quick_reply_icon']);
			return false;
		}

		case 'who cares':
		{
			if (typeof formobj.quickreply != 'undefined')
			{
				formobj.quickreply.checked = false;
			}
			break;
		}
	}

	if (clickedelm == formobj.preview.value)
	{
		minchars = 0;
	}

	return vB_Editor[QR_EditorID].prepare_submit(0, minchars);
}

/**
* Sends quick reply data to newreply.php via AJAX
*
* @param	string	GET string for action (newreply.php)
* @param	string	String representing form data ('x=1&y=2&z=3' etc.)
* @param	string	String representing form unique id
*/
function qr_ajax_post(submitaction, submitstring, frmid)
{
	if (YAHOO.util.Connect.isCallInProgress(qr_ajax))
	{
		YAHOO.util.Connect.abort(qr_ajax);
	}

	qr_repost = false;

	qr_ajax = YAHOO.util.Connect.asyncRequest("POST", submitaction, {
		success: qr_do_ajax_post,
		failure: qr_handle_error,
		//scope: this,
		timeout: vB_Default_Timeout,
		argument: {
			formid: frmid
		}
	}, SESSIONURL + "securitytoken=" + SECURITYTOKEN + '&' + submitstring);
}

/**
* Handles an unspecified AJAX error
*
* @param	object	YUI AJAX
*/
function qr_handle_error(ajax)
{
	vBulletin_AJAX_Error_Handler(ajax);

	if (typeof id == 'undefined') {
		id = '';
	}

	fetch_object('qr_posting_msg' + id).style.display = 'none';
	document.body.style.cursor = 'default';

	qr_resubmit(id);
}

/**
* Handles quick reply data when AJAX says qr_ajax_post() is complete
*
* @param	object	YUI AJAX
*/
function qr_do_ajax_post(ajax)
{
	var id = '';

	if (ajax.responseXML)
	{
		// Which form made the request?
		var formid = (ajax.argument && ajax.argument.formid ? ajax.argument.formid : ''),
			lastpost = 'lastpost';

		if (formid)
		{
			QR_EditorID = (jQuery('#' + formid).data('editor') || QR_EditorID);
			id = vB_Editor[QR_EditorID].editorname;

			var parents = jQuery('#' + formid).parents('div[id^="posts"]');
			if (parents.length > 0)
			{
				lastpost = lastpost + parents[0].id.substr(5); // substr("posts".length)
			}

		}

		document.body.style.cursor = 'auto';
		fetch_object('qr_posting_msg' + id).style.display = 'none';
		var i;

		if (fetch_tag_count(ajax.responseXML, 'postbit'))
		{
			var tid = ajax.responseXML.getElementsByTagName('thread')[0].firstChild.nodeValue;

			ajax_last_post['t' + tid] = ajax.responseXML.getElementsByTagName('time')[0].firstChild.nodeValue;
			qr_disable_controls();
			qr_hide_errors();

			var postbits = ajax.responseXML.getElementsByTagName('postbit');
			var postbitslength = postbits.length;
			for (i = 0; i < postbitslength; i++)
			{
				var newdiv = document.createElement('div');
				newdiv.innerHTML = postbits[i].firstChild.nodeValue;
				var lp = fetch_object(lastpost);
				var lpparent = lp.parentNode;
				var postbit = lpparent.insertBefore(newdiv, lp);

				PostBit_Init(postbit, postbits[i].getAttribute('postid'));

				if (i == (postbitslength - 1) && QR_EditorID == 'vB_Editor_MB')
				{
					var newdivtop = $('#' + newdiv.firstElementChild.id).offset().top;
					newdivtop = ($(window).scrollTop() > newdivtop) ? newdivtop - $('header').height() : newdivtop;

					$('html, body').animate({
						scrollTop: newdivtop
					}, 500);
				}
			}

			// unfocus the qr_submit button to prevent a space from resubmitting
			if (fetch_object('qr_submit' + id))
			{
				fetch_object('qr_submit' + id).blur();
			}

			// If we are using Gallery3 we need to clear the image list
			var gallery_image_list_object = fetch_object(QR_EditorID + '_gallery_image_list');
			if (gallery_image_list_object != null)
			{
				gallery_image_list_object.value = '';
			}
		}
		else
		{
			if (!is_saf || is_chrome)
			{
				// this is the nice error handler, of which Safari makes a mess
				var errors = ajax.responseXML.getElementsByTagName('error');
				if (errors.length)
				{
					var error_html = '<ol>';
					for (i = 0; i < errors.length; i++)
					{
						error_html += '<li>' + errors[i].firstChild.nodeValue + '</li>';
					}
					error_html += '</ol>';

					qr_show_errors('<ol>' + error_html + '</ol>');

					return false;
				}
			}

			qr_resubmit(id);
		}
	}
	else
	{
		qr_resubmit(id);
	}
}

/**
* Un-hides the quick reply errors element
*
* @param	string	Error(s) to show
*
* @return	boolean	false
*/
function qr_show_errors(errortext)
{
	var id = vB_Editor[QR_EditorID].editorname;
	qr_errors_shown = true;
	fetch_object('qr_error_td' + id).innerHTML = errortext;
	fetch_object('qr_error_tbody' + id).style.display = '';

	return false;
}

/**
* Hides the quick reply errors element
*
* @return	boolean	false
*/
function qr_hide_errors()
{
	if (qr_errors_shown)
	{
		qr_errors_shown = true;
		fetch_object('qr_error_tbody' + vB_Editor[QR_EditorID].editorname).style.display = 'none';
		return false;
	}
}

var vB_QuickReply = true;
